View Issue Details

IDProjectCategoryView StatusLast Update
0003547GNUnetgnunet-setuppublic2018-06-07 00:25
ReporterellAssigned ToChristian Grothoff 
PrioritynormalSeverityminorReproducibilityhave not tried
Status closedResolutionfixed 
PlatformOSXubuntu-14.04.1 LTSOS Version
Product VersionSVN HEAD 
Target Version0.11.0pre66Fixed in Version0.11.0pre66 
Summary0003547: Revision 34321, gnunet-setup dies
DescriptionRunning
 gnunet-setup -c /etc/gnunet.conf
under root-account in the directory
 /var/run/gnunet
crashes and leaves 3 running processes
 3400 pts/1 S 0:00 gnunet-service-identity
 3401 pts/1 S 0:00 gnunet-service-namestore
 3402 pts/1 S 0:00 gnunet-service-resolver
but does not alter /etc/gnunet.conf
Steps To Reproduceroot@Xubu-14:/var/run/gnunet# whoami
root
root@Xubu-14:/var/run/gnunet# pwd
/var/run/gnunet
root@Xubu-14:/var/run/gnunet# ls -l
insgesamt 0
root@Xubu-14:/var/run/gnunet# gdb gnunet-setup
gdb: warning: error finding working directory: Datei oder Verzeichnis nicht gefunden
GNU gdb (Ubuntu 7.7-0ubuntu3.1) 7.7
Copyright (C) 2014 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This GDB was configured as "x86_64-linux-gnu".
Reading symbols from gnunet-setup...done.
(gdb) run -c /etc/gnunet.conf
Starting program: /usr/local/bin/gnunet-setup -c /etc/gnunet.conf
shell-init: Kann das aktuelle Verzeichnis nicht wiederfinden: getwd: Kann auf das ├╝bergeordnete Verzeichnis nicht zugreifen.: Datei oder Verzeichnis nicht gefunden
[Thread debugging using libthread_db enabled]
Using host libthread_db library "/lib/x86_64-linux-gnu/libthread_db.so.1".
[New Thread 0x7fffed9a6700 (LWP 3394)]
[New Thread 0x7fffecf88700 (LWP 3395)]
[New Thread 0x7fffe7fff700 (LWP 3396)]
[New Thread 0x7fffe77fe700 (LWP 3397)]
[New Thread 0x7fffe6ffd700 (LWP 3398)]
[Thread 0x7fffecf88700 (LWP 3395) exited]
[Thread 0x7fffe77fe700 (LWP 3397) exited]

-->Click to "Transport"-->Click to "Test configuration" (tcp)

Okt 02 10:06:37-004572 util-scheduler-3390 ERROR Attempt to cancel dead task 1463!
Okt 02 10:06:37-004847 gnunet-setup-3390 ERROR Assertion failed at scheduler.c:950.

Program received signal SIGABRT, Aborted.
0x00007ffff6097bb9 in __GI_raise (sig=sig@entry=6) at ../nptl/sysdeps/unix/sysv/linux/raise.c:56
56 ../nptl/sysdeps/unix/sysv/linux/raise.c: Datei oder Verzeichnis nicht gefunden.
(gdb) quit
A debugging session is active.

    Inferior 1 [process 3390] will be killed.

Quit anyway? (y or n) y
Additional Information/etc/gnunet.conf is not empty. I filled it manually but would like to
improve it with gnunet-setup.
TagsNo tags attached.

Activities

Christian Grothoff

2014-10-03 22:52

manager   ~0008594

While I wasn't able to reproduce this one exactly, I fixed a few issues in SVN 34331 (and a few earlier revisions) that may cause / explain this issue. Please re-open if you can still reproduce. In this case, the output of "ba" in gdb upon encountering the crash would be helpful.

Please note that the fixes require recompiling both GNUnet and GNUnet-GTK.

ell

2014-10-05 18:03

reporter   ~0008599

I recompiled all for Revision 34353 and got:

root@Xubu-14:~# pwd
/root
root@Xubu-14:~# ps ax | grep gnunet
16346 pts/11 S+ 0:00 grep --color=auto gnunet
root@Xubu-14:~# gdb gnunet-setup
GNU gdb (Ubuntu 7.7-0ubuntu3.1) 7.7
...
Reading symbols from gnunet-setup...done.
(gdb) run -c /etc/gnunet.conf
Starting program: /usr/local/bin/gnunet-setup -c /etc/gnunet.conf
[Thread debugging using libthread_db enabled]
Using host libthread_db library "/lib/x86_64-linux-gnu/libthread_db.so.1".
[New Thread 0x7fffed9a5700 (LWP 16353)]
[New Thread 0x7fffecf87700 (LWP 16354)]
[New Thread 0x7fffe7fff700 (LWP 16355)]
[New Thread 0x7fffe77fe700 (LWP 16356)]
[Thread 0x7fffecf87700 (LWP 16354) exited]

Program received signal SIGSEGV, Segmentation fault.
GNUNET_NAT_test_stop (tst=0x555555e03be0) at nat_test.c:537
537 GNUNET_CONTAINER_DLL_remove (tst->na_head, tst->na_tail, pos);
(gdb) ba
#0 GNUNET_NAT_test_stop (tst=0x555555e03be0) at nat_test.c:537
#1 0x0000555555561d71 in display_test_result (result=<optimized out>, tc=0x555555aad1b0)
    at gnunet-setup-transport-test.c:88
#2 result_callback (cls=0x555555aad1b0, result=<optimized out>) at gnunet-setup-transport-test.c:111
#3 0x00007ffff7760c50 in do_read (cls=0x555555a36870, tc=<optimized out>) at nat_test.c:262
#4 0x00007ffff79ac08c in run_ready (ws=0x55555577ffc0, rs=0x555555796720) at scheduler.c:595
#5 GNUNET_SCHEDULER_run (task=task@entry=0x7ffff79a6b00 <program_main>,
    task_cls=task_cls@entry=0x7fffffffe1c0) at scheduler.c:817
#6 0x00007ffff79a7313 in GNUNET_PROGRAM_run2 (argc=<optimized out>, argc@entry=3, argv=0x7fffffffe5d8,
    binaryName=binaryName@entry=0x5555555660e2 "gnunet-setup",
    binaryHelp=binaryHelp@entry=0x5555555660e2 "gnunet-setup", options=<optimized out>,
    task=task@entry=0x7ffff7bd50f0 <run_main_loop>, task_cls=task_cls@entry=0x7fffffffe390,
    run_without_scheduler=run_without_scheduler@entry=0) at program.c:286
#7 0x00007ffff79a766a in GNUNET_PROGRAM_run (argc=argc@entry=3, argv=<optimized out>,
    binaryName=binaryName@entry=0x5555555660e2 "gnunet-setup",
    binaryHelp=binaryHelp@entry=0x5555555660e2 "gnunet-setup", options=<optimized out>,
    task=task@entry=0x7ffff7bd50f0 <run_main_loop>, task_cls=task_cls@entry=0x7fffffffe390) at program.c:325
#8 0x00007ffff7bd6183 in GNUNET_GTK_main_loop_start (binary_name=0x5555555660e2 "gnunet-setup",
    binary_help=0x5555555660e2 "gnunet-setup", argc=3, argv=<optimized out>, options=<optimized out>,
    main_window_file=<optimized out>, main_task=0x55555555fb20 <run>) at eventloop.c:1000
#9 0x000055555555ed0c in main (argc=<optimized out>, argv=<optimized out>) at gnunet-setup.c:677
(gdb) quit
A debugging session is active.

    Inferior 1 [process 16349] will be killed.

Quit anyway? (y or n) y
root@Xubu-14:~#

Christian Grothoff

2014-10-05 18:06

manager   ~0008600

Did you really run 'make install', or just 'make'?

ell

2014-10-05 18:27

reporter   ~0008601

I really did
  sudo make install (after bootstrap, configure...)
in the new
 svn checkout
living in the new dir /home/ell/gnunet
(gnunet was empty at checkout-time)

Same for gnunet-gtk

ell

2014-10-06 15:11

reporter   ~0008604

Using gnunet-transport instead of gnunet-setup seems to work.

root@Xubu-14:~# gnunet-transport -t -c /etc/gnunet.conf
Configuration for plugin `tcp' did work!
Configuration for plugin `tcp' is working!
Configuration for plugin `udp' did work!
Configuration for plugin `udp' is working!
root@Xubu-14:~# gnunet-setup -c /etc/gnunet.conf
Speicherzugriffsfehler
root@Xubu-14:~#

Christian Grothoff

2014-10-20 13:20

manager   ~0008609

Was able to reproduce this now on another system (spec):

Program received signal SIGSEGV, Segmentation fault.
GNUNET_NAT_test_stop (tst=0x6de300) at nat_test.c:537
537 GNUNET_CONTAINER_DLL_remove (tst->na_head, tst->na_tail, pos);
(gdb) ba
#0 GNUNET_NAT_test_stop (tst=0x6de300) at nat_test.c:537
#1 0x0000000000407251 in display_test_result (tc=0xb550f0, result=1) at gnunet-setup-transport-test.c:88
#2 0x00000000004072c0 in result_callback (cls=0xb550f0, result=GNUNET_NAT_ERROR_SUCCESS) at gnunet-setup-transport-test.c:111
#3 0x00007ffff713b08c in do_read (cls=0xb47d10, tc=<optimized out>) at nat_test.c:262
#4 0x00007ffff7384222 in run_ready (ws=0x625880, rs=0x6257f0) at scheduler.c:595
#5 GNUNET_SCHEDULER_run (task=task@entry=0x7ffff737ea50 <program_main>, task_cls=task_cls@entry=0x7fffffffe360) at scheduler.c:817
#6 0x00007ffff737f1d2 in GNUNET_PROGRAM_run2 (argc=<optimized out>, argv=0x7fffffffe798, binaryName=<optimized out>, binaryHelp=<optimized out>, options=<optimized out>,
    task=<optimized out>, task_cls=task_cls@entry=0x7fffffffe550, run_without_scheduler=run_without_scheduler@entry=0) at program.c:286
#7 0x00007ffff737f50a in GNUNET_PROGRAM_run (argc=<optimized out>,
argv=<optimized out>, binaryName=<optimized out>, binaryHelp=<optimized out>, options=<optimized out>,
    task=<optimized out>, task_cls=0x7fffffffe550) at program.c:325
#8 0x00007ffff7bd83c7 in GNUNET_GTK_main_loop_start (binary_name=0x40b17f "gnunet-setup", binary_help=0x40b17f "gnunet-setup", argc=1, argv=0x7fffffffe798, options=0x7fffffffe600,
    main_window_file=0x40b160 "gnunet_setup_main_window.glade", main_task=0x405950 <run>) at eventloop.c:1000
#9 0x0000000000405c78 in main (argc=1, argv=0x7fffffffe798) at gnunet-setup.c:677

Christian Grothoff

2014-10-20 13:20

manager   ~0008610

valgrind report:
==1517== Invalid read of size 8
==1517== at 0x58D8EC4: GNUNET_NAT_test_stop (nat_test.c:529)
==1517== by 0x407250: display_test_result (gnunet-setup-transport-test.c:88)
==1517== by 0x4072BF: result_callback (gnunet-setup-transport-test.c:111)
==1517== by 0x58D808B: do_read (nat_test.c:262)
==1517== by 0x56AB221: run_ready (scheduler.c:595)
==1517== by 0x56AB221: GNUNET_SCHEDULER_run (scheduler.c:817)
==1517== by 0x56A61D1: GNUNET_PROGRAM_run2 (program.c:286)
==1517== by 0x56A6509: GNUNET_PROGRAM_run (program.c:325)
==1517== by 0x4E3B3C6: GNUNET_GTK_main_loop_start (eventloop.c:1000)
==1517== by 0x405C77: main (gnunet-setup.c:677)
==1517== Address 0x17b7e1b8 is 56 bytes inside a block of size 104 free'd
==1517== at 0x4C29E90: free (vg_replace_malloc.c:473)
==1517== by 0x40729F: result_callback (gnunet-setup-transport-test.c:109)
==1517== by 0x58D808B: do_read (nat_test.c:262)
==1517== by 0x56AB221: run_ready (scheduler.c:595)
==1517== by 0x56AB221: GNUNET_SCHEDULER_run (scheduler.c:817)
==1517== by 0x56A61D1: GNUNET_PROGRAM_run2 (program.c:286)
==1517== by 0x56A6509: GNUNET_PROGRAM_run (program.c:325)
==1517== by 0x4E3B3C6: GNUNET_GTK_main_loop_start (eventloop.c:1000)
==1517== by 0x405C77: main (gnunet-setup.c:677)
==1517==
==1517== Invalid read of size 8
==1517== at 0x58D8ED1: GNUNET_NAT_test_stop (nat_test.c:531)
==1517== by 0x407250: display_test_result (gnunet-setup-transport-test.c:88)
==1517== by 0x4072BF: result_callback (gnunet-setup-transport-test.c:111)
==1517== by 0x58D808B: do_read (nat_test.c:262)
==1517== by 0x56AB221: run_ready (scheduler.c:595)
==1517== by 0x56AB221: GNUNET_SCHEDULER_run (scheduler.c:817)
==1517== by 0x56A61D1: GNUNET_PROGRAM_run2 (program.c:286)
==1517== by 0x56A6509: GNUNET_PROGRAM_run (program.c:325)
==1517== by 0x4E3B3C6: GNUNET_GTK_main_loop_start (eventloop.c:1000)
==1517== by 0x405C77: main (gnunet-setup.c:677)
==1517== Address 0xdf0adba0df0adba is not stack'd, malloc'd or (recently) free'd
==1517==
==1517==
==1517== Process terminating with default action of signal 11 (SIGSEGV): dumping core
==1517== General Protection Fault
==1517== at 0x58D8ED1: GNUNET_NAT_test_stop (nat_test.c:531)
==1517== by 0x407250: display_test_result (gnunet-setup-transport-test.c:88)
==1517== by 0x4072BF: result_callback (gnunet-setup-transport-test.c:111)
==1517== by 0x58D808B: do_read (nat_test.c:262)
==1517== by 0x56AB221: run_ready (scheduler.c:595)
==1517== by 0x56AB221: GNUNET_SCHEDULER_run (scheduler.c:817)
==1517== by 0x56A61D1: GNUNET_PROGRAM_run2 (program.c:286)
==1517== by 0x56A6509: GNUNET_PROGRAM_run (program.c:325)
==1517== by 0x4E3B3C6: GNUNET_GTK_main_loop_start (eventloop.c:1000)
==1517== by 0x405C77: main (gnunet-setup.c:677)
==1517==

Christian Grothoff

2014-10-20 13:23

manager   ~0008611

Fixed in SVN 34375.

Issue History

Date Modified Username Field Change
2014-10-02 11:01 ell New Issue
2014-10-03 22:52 Christian Grothoff Note Added: 0008594
2014-10-03 22:52 Christian Grothoff Status new => resolved
2014-10-03 22:52 Christian Grothoff Fixed in Version => 0.11.0pre66
2014-10-03 22:52 Christian Grothoff Resolution open => fixed
2014-10-03 22:52 Christian Grothoff Assigned To => Christian Grothoff
2014-10-03 22:52 Christian Grothoff Target Version => 0.11.0pre66
2014-10-05 18:03 ell Note Added: 0008599
2014-10-05 18:03 ell Status resolved => feedback
2014-10-05 18:03 ell Resolution fixed => reopened
2014-10-05 18:06 Christian Grothoff Note Added: 0008600
2014-10-05 18:27 ell Note Added: 0008601
2014-10-05 18:27 ell Status feedback => assigned
2014-10-06 15:11 ell Note Added: 0008604
2014-10-20 13:20 Christian Grothoff Note Added: 0008609
2014-10-20 13:20 Christian Grothoff Note Added: 0008610
2014-10-20 13:23 Christian Grothoff Note Added: 0008611
2014-10-20 13:23 Christian Grothoff Status assigned => resolved
2014-10-20 13:23 Christian Grothoff Resolution reopened => fixed
2018-06-07 00:25 Christian Grothoff Status resolved => closed